#include<stdio.h>

long long Pojedeno(long long d[], long long p[], int N, long long k){
    long long u = 0, pojedeno = 0, j = 0;
    for (long long i = 1; i <= k; i++) {
        while (j < N && d[j] == i) {
            u += p[j];
            j++;
        }
        if (u > 0) {
            u--;
            pojedeno++;
        }
    }
    return pojedeno;
}

int main() {
    int N,Q,i,j;

    scanf("%d%d", &N, &Q);

    long long d[N], p[N], k[Q];



    for(i=0;i<N;i++){
        scanf("%lld%lld",&d[i],&p[i]);
    }

    for(i=0;i<Q;i++){
        scanf("%lld",&k[i]);
    }

    for (int i = 0; i < Q; i++) {
        printf("%lld\n", Pojedeno(d, p, N, k[i]));
    }
}